
this.name = 'Stashes';
this.copyright = '(C) 2015 Popsch.';
this.licence = 'CC-NC-by-SA 2.0';

this.debugProximityTrap = 0;

'use strict';

/** Distance at which a warning message gets triggered */
this.proximityWarning = 23000;

/** Distance at which the alarm gets triggered */
this.proximityAlert = 15010;

/** Likelyhood of police trap present */
this.TrapLikelihood = 0.02;
//this.TrapLikelihood = 1;

this.trapPosition;

this.TRAP_SPRUNG = 0;
this.TRAP_ACTIVE = 1;

this.trapState = TRAP_ACTIVE;

this.trapType = 0;

var buoy = null;

this.$sendMilitaryWarning = function() {
    buoy.commsMessage('WARNING! Commander ' + player.name + ': You have entered restricted military space. Leave immediately. Last warning!', player.ship);
};

this.$sendNormalWarning = function() {
    buoy.commsMessage('WARNING! Restricted space. Turn around immediately!', player.ship);
};

this.$respondAlertMilitary = function() {
    player.bounty += 100;

    s = system.addShips('police', 3, player.ship.position, 10000);
    s.forEach(function(entry) {
        entry.target = player.ship;
        entry.performAttack();
    });
    s[0].commsMessage('ALARM! A spy. Get him!', player.ship);
};

this.$respondAlertRaiders = function() {
    s = system.addShips('pirate', 4, player.ship.position, 10000);
    s.forEach(function(entry) {
        entry.target = player.ship;
        entry.performAttack();
    });
    s[0].commsMessage('Hey John, I told you someone will fall for this. Let\'s get him!', s[1]);
};

this.$respondAlertPolice = function() {
    player.bounty += 25;

    s = system.addShips('police', 1, player.ship.position, 10000);
    s.forEach(function(entry) {
        entry.target = player.ship;
        entry.performAttack();
    });
    s[0].commsMessage('I knew this trap would be the best way to up my arrest record!', player.ship);
};

this.$respondAlertMerchant = function() {
    buoy.commsMessage('Intruder alert!', player.ship);
    for (i = 0; i < 2; i++) {
        var adder = system.addShips('[adder]', 1, buoy.position, 100)[0];
        adder.target = player.ship;
        adder.awardEquipment('EQ_HARDENED_MISSILE');
        adder.fireMissile();
        adder.remove();
    }
    // keep the trap active
    this.trapState = TRAP_ACTIVE;
    this.distanceChecker = new Timer(this, this.$checkDistance, 4);
};

this.$respondAlertAbandoned = function() {
    buoy.commsMessage('Intruder alert!', player.ship);
};

this.$respondAlertMalfunction = function() {
    buoy.commsMessage('ALAR... (bbbrzzzt) (beep) (pffff)', player.ship);
};

var TRAPS = [
//prob, min-pods, max-pods, warning callback, alert callback
    0.05, 4, 7, this.$sendMilitaryWarning, this.$respondAlertMilitary,
    0.20, 3, 7, this.$sendNormalWarning, this.$respondAlertRaiders,
    0.30, 3, 4, this.$sendNormalWarning, this.$respondAlertPolice,
    0.70, 3, 7, this.$sendNormalWarning, this.$respondAlertMerchant,
    0.85, 0, 0, this.$sendNormalWarning, this.$respondAlertAbandoned,
    1.00, 3, 7, this.$sendNormalWarning, this.$respondAlertMalfunction
];


/** launch from station for testing */
this.shipWillLaunchFromStation = function() {
    if (this.debugProximityTrap != 1) return;

    log(this.name, 'Ship LAUNCHED.');
    log(this.name, TRAPS);
    player.ship.position = system.locationFromCode('OUTER_SYSTEM_OFFPLANE');

    this.$populateWithTrap(player.ship.position.add([1E4, 1E4, 1E4]));
};

this.$pickTrap = function() {
    x = system.scrambledPseudoRandomNumber(clock.seconds);
    for (idx = 0; idx < TRAPS.length; idx += 5) {
        // log(this.name, x + ' :: ' + idx + ' :: ' + TRAPS[idx]);
        if (x < TRAPS[idx]) {
            return (idx / 5);
        }
    }
    return (idx / 5);
};

this.$populateWithTrap = function(pos) {
    this.trapType = this.$pickTrap();
    this.trapState = TRAP_ACTIVE;
    log(this.name, 'initialize trap type: ' + this.trapType);

    // location of the stash
    this.trapPosition = pos;

    // instantiate cargopods
    pods = Math.floor(system.scrambledPseudoRandomNumber(clock.seconds) * (TRAPS[this.trapType * 5 + 2] - TRAPS[this.trapType * 5 + 1] + 1)) + TRAPS[this.trapType * 5 + 1];

    if (pods != 0)
        system.addShips('cargopod', pods, this.trapPosition, 1000);

    buoy = system.addShips('nofly_buoy', 1, this.trapPosition, 1000);
    buoy = buoy[0];

    this.distanceChecker = new Timer(this, this.$checkDistance, 5, 5);
};

/** launch from station for testing */
this.systemWillPopulate = function(station) {

    if (system.scrambledPseudoRandomNumber(clock.seconds) < this.TrapLikelihood * system.techLevel) {
        //player.commsMessage('This system looks interesting!');
        system.setPopulator('trap', {
            callback: function(pos) {
                this.$populateWithTrap(pos);
            }.bind(this),
            location: 'LANE_WP'
        });
    }
};


/** Timer function callback to check the distance to the player */
this.$checkDistance = function() {

    if (this.trapState != TRAP_ACTIVE) {
        // how can we still be here?
        // nevertheless, defensive programming
        log(this.name, 'trapstate not active (' + this.trapState + '); disable checker.');
        this.distanceChecker.stop();
        return;
    }

    ships = system.filteredEntities(this,
                                    function $isNoFlyBuoy(entity) {
                                        return (entity.primaryRole == 'nofly_buoy');
                                    },
                                    player.ship, 25600);


    if (ships == null) return; // nothing close
    if (ships.length == 0) return; // nothing close

    // de-array
    ship = ships[0];

    distance = player.ship.position.distanceTo(ship);

    //log(this.name, 'distance from buoy:' + distance);

    // proximity alert must come first before warning due to 'return' statement
    if (distance < this.proximityAlert) {
        this.trapState = this.TRAP_SPRUNG;
        log(this.name, 'Stopping timer since the alarm went off.');
        this.distanceChecker.stop();

        //log(this.name, 'issuing alert ('+ (this.trapType * 5 + 4) +'):'+TRAPS[this.trapType * 5 + 4]);

        TRAPS[this.trapType * 5 + 4]();
        return;
    }

    if (distance < this.proximityWarning) {
        //log(this.name, 'issuing waring ('+ (this.trapType * 5 + 3) +'): '+TRAPS[this.trapType * 5 + 3]);
        TRAPS[this.trapType * 5 + 3]();
        return;
    }
};
